/*
 * param.h: Command-line Parameter passing definitions
 *
 * Author: John DiMarco, University of Toronto, CDF
 *         jdd@cdf.toronto.edu
 *
 * $Id: param.h,v 1.2 1999/04/19 23:46:09 jdd Exp $
 */

/* defined in scsiinfo.c */
extern int parameter; 
extern u_int devicecount;
extern char *osrelease;

/* max 32 parameters before we need to worry about portability */
#define P_CONTROLLER 0
#define P_SUNOS4STYLE 1
#define P_PROBE 2
#define P_QUIET 3
#define P_ORIGINAL 4
#define P_REPORT 5
#define P_FORMATDAT 6
#define P_SYNCH 7

#define set_param(a) (parameter |= 1<<(a))
#define clear_param(a) (parameter &= ~(1<<(a)))
#define param_is_set(a) (parameter & 1<<(a))
