/*
 * sunos4.h: SunOS 4.1.x dependent code. 
 *
 * Author: John DiMarco, University of Toronto, CDF
 *         jdd@cdf.toronto.edu
 *
 * modified by Michael Lowry, Princeton University, Physics
 *         mml@pupcyc2.princeton.edu
 *    to use the scsi_device list to obtain target and lun values
 * 
 * $Id: sunos4.h,v 1.10 1997/04/20 21:46:39 jdd Exp $
 */

#define _mon_openprom_h /* SunOS 4.1.2 silliness */

extern struct dev_info devi;

/* make sure these match up with the def'n of nl in sunos4.c */
#define N_NESP 0
#define N_ESP_SOFTC 1
#define N_SD_ROOT 2
#define N_NPTISP 3
#define N_PTISP_SOFTC 4

extern struct nlist nl[]; 

#ifndef NPHASE
#define OLD_SUNOS /* SunOS 4.1.1 or earlier */
#undef CNUM
#define CNUM (esp_p-esp_softc)
#endif

#include <sun/openprom.h>
#define ddi_get_unit(a) ((struct dev_info *)a)->devi_unit
#define ddi_get_name(a) ((struct dev_info *)a)->devi_name
#define ddi_get_child(a) ((struct dev_info *)a)->devi_slaves
#define ddi_get_parent(a) ((struct dev_info *)a)->devi_parent
#define ddi_get_next_sibling(a) ((struct dev_info *)a)->devi_next
#define DDI_CF2(a) (NULL != ((struct dev_info *)a)->devi_driver)
typedef struct dev_info *dev_info_t;


/*
 * device name is DEV_PREFIX<device>DEV_INFIX<addr>DEV_SUFFIX,
 * disk device name is DEV_PREFIX<device>DEV_INFIX<addr>DISK_SUFFIX,
 * 
 * For SunOS4: r<device><addr> or r<device><addr>c for disk
 */
#define DEV_PREFIX "r"
#define DEV_INFIX ""
#define DEV_SUFFIX ""
#define DISK_SUFFIX "c"
#define TAPE_PREFIX "nr"
#define TAPE_SUFFIX ""

extern void init_scsitarget();
extern int get_scsiaddr();
extern char *get_addr();
extern char *get_devicepath();

#ifdef ESP_SUPPORT
extern u_int get_nesp();
#endif /* ESP_SUPPORT */

#ifdef ISP_SUPPORT
/* ISP controller not supported under SunOS 4.x */
#undef ISP_SUPPORT
#endif /* ISP_SUPPORT */

#ifdef FAS_SUPPORT
/* FAS controller not supported under SunOS 4.x */
#undef FAS_SUPPORT
#endif /* FAS_SUPPORT */

#ifdef PTISP_SUPPORT
extern u_int get_nptisp();
#endif /* PTISP_SUPPORT */
